Package org.eclipse.gef.editpolicies

# Class ConnectionEndpointEditPolicy

java.lang.Object
org.eclipse.gef.editpolicies.AbstractEditPolicy
org.eclipse.gef.editpolicies.GraphicalEditPolicy
org.eclipse.gef.editpolicies.SelectionEditPolicy
org.eclipse.gef.editpolicies.SelectionHandlesEditPolicy
org.eclipse.gef.editpolicies.ConnectionEndpointEditPolicy

All Implemented Interfaces:
  `IAdaptable`, `EditPolicy`, `RequestConstants`

public class ConnectionEndpointEditPolicy extends SelectionHandlesEditPolicy
A selection handle policy for placing handles at the two ends of a ConnectionEditPart. All ConnectionEditParts should have one of these, even if the ends of the connection aren't draggable, because this is the primary SelectionEditPolicy for showing focus.

A connection can receive focus but not selection by pressing `Control+/` on the keyboard.

Since:
  2.0

## Field Summary

### Fields inherited from class org.eclipse.gef.editpolicies.SelectionHandlesEditPolicy

`handles`

### Fields inherited from interface org.eclipse.gef.EditPolicy

`COMPONENT_ROLE, CONNECTION_BENDPOINTS_ROLE, CONNECTION_ENDPOINTS_ROLE, CONNECTION_ROLE, CONTAINER_ROLE, DIRECT_EDIT_ROLE, GRAPHICAL_NODE_ROLE, LAYOUT_ROLE, NODE_ROLE, PRIMARY_DRAG_ROLE, SELECTION_FEEDBACK_ROLE, TREE_CONTAINER_ROLE`

### Fields inherited from interface org.eclipse.gef.RequestConstants

`REQ_ADD, REQ_ALIGN, REQ_ALIGN_CHILDREN, REQ_CLONE, REQ_CONNECTION_END, REQ_CONNECTION_START, REQ_CREATE, REQ_CREATE_BENDPOINT, REQ_DELETE, REQ_DELETE_DEPENDANT, REQ_DIRECT_EDIT, REQ_MOVE, REQ_MOVE_BENDPOINT, REQ_MOVE_CHILDREN, REQ_OPEN, REQ_ORPHAN, REQ_ORPHAN_CHILDREN, REQ_RECONNECT_SOURCE, REQ_RECONNECT_TARGET, REQ_RESIZE, REQ_RESIZE_CHILDREN, REQ_SELECTION, REQ_SELECTION_HOVER`

## Constructor Summary

Constructors
Constructor
Description
`ConnectionEndpointEditPolicy()`

## Method Summary

Modifier and Type
Method
Description
`protected List<? extends ConnectionEndpointHandle>`
`createSelectionHandles()`
Subclasses must implement to provide the list of handles.
`protected void`
`eraseConnectionMoveFeedback(ReconnectRequest request)`
Erases connection move feedback.
`void`
`eraseSourceFeedback(Request request)`
Does nothing by default.
`Command`
`getCommand(Request request)`
Returns `null` by default.
`protected org.eclipse.draw2d.Connection`
`getConnection()`
Convenience method for obtaining the host's `Connection` figure.
`protected FeedbackHelper`
`getFeedbackHelper(ReconnectRequest request)`
Lazily creates and returns the feedback helper for the given request.
`protected void`
`hideFocus()`
Hides the focus indicator.
`protected void`
`showConnectionMoveFeedback(ReconnectRequest request)`
Shows or updates connection move feedback.
`protected void`
`showFocus()`
Shows focus around the connection.
`void`
`showSourceFeedback(Request request)`
Does nothing by default.

### Methods inherited from class org.eclipse.gef.editpolicies.SelectionHandlesEditPolicy

`addSelectionHandles, getAdapter, hideSelection, removeSelectionHandles, showSelection`

### Methods inherited from class org.eclipse.gef.editpolicies.SelectionEditPolicy

`activate, addSelectionListener, deactivate, getTargetEditPart, removeSelectionListener, setFocus, setSelectedState, showPrimarySelection`

### Methods inherited from class org.eclipse.gef.editpolicies.GraphicalEditPolicy

`addFeedback, getFeedbackLayer, getHost, getHostFigure, getLayer, removeFeedback`

### Methods inherited from class org.eclipse.gef.editpolicies.AbstractEditPolicy

`debugFeedback, eraseTargetFeedback, setHost, showTargetFeedback, toString, understandsRequest`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ConnectionEndpointEditPolicy

public ConnectionEndpointEditPolicy()

## Method Details

### createSelectionHandles

protected List<? extends ConnectionEndpointHandle> createSelectionHandles()
Description copied from class: `SelectionHandlesEditPolicy`
Subclasses must implement to provide the list of handles.

Specified by:
  `createSelectionHandles` in class `SelectionHandlesEditPolicy`
Returns:
  List of handles; cannot be `null`
See Also:
  - `SelectionHandlesEditPolicy.createSelectionHandles()`

### eraseConnectionMoveFeedback

protected void eraseConnectionMoveFeedback(ReconnectRequest request)
Erases connection move feedback. This method is called when a ReconnectRequest is received.

Parameters:
  `request` - the reconnect request.

### eraseSourceFeedback

public void eraseSourceFeedback(Request request)
Description copied from class: `AbstractEditPolicy`
Does nothing by default.

Specified by:
  `eraseSourceFeedback` in interface `EditPolicy`
Overrides:
  `eraseSourceFeedback` in class `AbstractEditPolicy`
Parameters:
  `request` - the Request
See Also:
  - `EditPolicy.eraseSourceFeedback(org.eclipse.gef.Request)`

### getCommand

public Command getCommand(Request request)
Description copied from class: `AbstractEditPolicy`
Returns `null` by default. `null` is used to indicate that the EditPolicy does not contribute to the specified `Request`.

Specified by:
  `getCommand` in interface `EditPolicy`
Overrides:
  `getCommand` in class `AbstractEditPolicy`
Parameters:
  `request` - the Request
Returns:
  `null` or a Command contribution
See Also:
  - `EditPolicy.getCommand(org.eclipse.gef.Request)`

### getConnection

protected org.eclipse.draw2d.Connection getConnection()
Convenience method for obtaining the host's `Connection` figure.

Returns:
  the Connection figure

### getFeedbackHelper

protected FeedbackHelper getFeedbackHelper(ReconnectRequest request)
Lazily creates and returns the feedback helper for the given request. The helper will be configured as either moving the source or target end of the connection.

Parameters:
  `request` - the reconnect request
Returns:
  the feedback helper

### hideFocus

protected void hideFocus()
Hides the focus indicator. The focus indicator is a dotted outline around the connection.

Overrides:
  `hideFocus` in class `SelectionEditPolicy`
See Also:
  - `showFocus()`
  - `SelectionEditPolicy.hideFocus()`

### showConnectionMoveFeedback

protected void showConnectionMoveFeedback(ReconnectRequest request)
Shows or updates connection move feedback. Called whenever a show feedback request is received for reconnection.

Parameters:
  `request` - the reconnect request

### showFocus

protected void showFocus()
Shows focus around the connection.

Overrides:
  `showFocus` in class `SelectionEditPolicy`
See Also:
  - `SelectionEditPolicy.showFocus()`

### showSourceFeedback

public void showSourceFeedback(Request request)
Description copied from class: `AbstractEditPolicy`
Does nothing by default.

Specified by:
  `showSourceFeedback` in interface `EditPolicy`
Overrides:
  `showSourceFeedback` in class `AbstractEditPolicy`
Parameters:
  `request` - the Request
See Also:
  - `EditPolicy.showSourceFeedback(org.eclipse.gef.Request)`